COMMON=["Ketinit","Fillstore","Setwindow","Windispg",
        "Drwxy","Measuredepth","Dashlinedata","Textformat","Invert"]; //190325

////%Makefunlist start////
Makefunlist():=Makefunlist(
  ["basic1","basic2","basic3","3d"]);
Makefunlist(libL):=(
  regional(lib,out,all,fL,jj,line,name,start,end,funinL,
     tmp,tmp1,tmp2,res);
  res=[];
  forall(libL,lib,
    out=[];
    tmp1=Dirhead+pathsep()+"ketlib";
    tmp2="ketcindylib"+lib+"r.cs";
    all=Readlines(tmp1,tmp2);
    fL=select(1..(length(all)),indexof(all_#,"////%")>0);
    forall(1..(length(fL)/2),jj,
      tmp=fL_(2*jj-1);
      line=all_tmp;
      if(indexof(line,"start")==0,
        println(["start not correct",tmp,line]);
      ,
        tmp=indexof(line,"%");
        tmp1=substring(line,tmp,length(line));
        tmp=indexof(tmp1," ");
        name=substring(tmp1,0,tmp-1);
        start=fL_(2*jj-1)+1;
      );
      tmp=fL_(2*jj);
      line=all_tmp;
      if(indexof(line,"end")==0,
        println(["end not correct",tmp,line]);
      ,
        end=fL_(2*jj)-1;
      );
      funinL=[];
      onlyflg=0; //190828
      forall(start..end,
        tmp1=all_#; //190828from
        if(indexof(tmp1,"only ketjs on")>0,onlyflg=1);
        if(indexof(tmp1,"only ketjs off")>0,onlyflg=0);
        if((onlyflg==1)%(indexof(tmp1,"only ketjs")>0),
          tmp1=Removespace(tmp1);
          tmp1=substring(tmp1,2,length(tmp1));
        );
        tmp=Findfun(name,tmp1); //190828to
        funinL=remove(funinL,tmp);
        funinL=concat(funinL,tmp);
      );
      tmp=[name,lib,start,end];
      forall(funinL,
        tmp=append(tmp,#);
      );
      tmp=text(tmp);
      tmp=substring(tmp,1,length(tmp)-1);
      out=append(out,tmp);
    );
    setdirectory(Dirhead+pathsep()+"ketcindyjs");
    fd=openfile(lib+"list.txt");
    res=concat(res,out);
    forall(out,
      println(fd,#);
    );
    closefile(fd);
  );
  tmp="Generate lists of functions";
  drawtext(mouse().xy-[0,1],tmp,size->20,color->[1,0,0]);
  wait(2000);
  res;
);
////%Makefunlist end////

////%Makecommon start////
Makecommon():=Makecommon([]);//["basic1","basic2","basic3"]);
Makecommon(libL):=(
  regional(lib,out,all,fL,jj,line,name,start,end,funinL,
     tmp,tmp1,tmp2,res,ketflg);
  all=[];
  forall(libL,lib,
    tmp1=Dirhead+pathsep()+"ketlib";
    tmp2="ketcindylib"+lib+"r.cs";
    tmp=Readlines(tmp1,tmp2);
    all=append(all,tmp);
  );
  res=[];
  tmp1=Dirhead+pathsep()+"ketcindyjs";
  forall(libL,lib,
    tmp2=lib+"list.txt";
    tmp=Readlines(tmp1,tmp2);
    res=concat(res,tmp);
  );
  out=[];
  forall(res,
    tmp=tokenize(#,",");
    if(contains(COMMON,tmp_1),
      out=append(out,[tmp_1,tmp_2,tmp_3,tmp_4]);
    );
  );
  fd=openfile("commonused.txt");
  forall(out,tmp1,
    jj=select(1..(length(libL)),tmp1_2==libL_#);
    jj=jj_1;
    tmp2=all_jj;
    start=tmp1_3;
    end=tmp1_4;
    ketflg="off";
    forall(start..end,
      tmp=tmp2_#;
      if(indexof(tmp,"no ketjs")>0,
        if(indexof(tmp,"no ketjs on")>0,
          ketflg="on";
        );
        if(indexof(tmp,"no ketjs off")>0,
          ketflg="off";
        );
      ,
        if(ketflg=="off",
          tmp1=Removespace(tmp);
          if(substring(tmp1,0,2)!="//",
            println(fd,tmp);
          );
        );
      );
    );
  );
  closefile(fd);
  tmp="Generate the file of common functions";
  drawtext(mouse().xy-[0,1],tmp,size->20,color->[1,0,0]);
  wait(2000);
);

Sortfuns():=(
  regional(tmp,funs);
  tmp=Dirhead+"/ketcindyjs";
  funs=Readlines(tmp,"ignoredfun.txt");
  funs=remove(funs,COMMON);
  funs=sort(funs);
  apply(funs,println(#));
);

Ketinit("");
Addax(0);

Windispg();


